
# A light-weight wrapper that registers and instantiates a test harness.

harness_name = "Python3 - unittest"

def instantiate_harness():
    import os
    import sys
    sys.path.insert(0, os.path.dirname(os.path.abspath(__file__)))
    try:
        import harness_python3_unittest
    finally:
        sys.path = sys.path[1:]
    return harness_python3_unittest.Python3_Unittest_SleuthHarness()

def register(sleuthManager):
    sleuthManager.register('Python3', harness_name, instantiate_harness)
