/* Copyright (c) 2003-2006 ActiveState Software Inc.
   See the file LICENSE.txt for licensing information. */


var log = ko.logging.getLogger("dialogs.invalidLicense");
//log.setLevel(ko.logging.LOG_DEBUG);

var gCancelButton = null;

var gInfoSvc = Components.classes["@activestate.com/koInfoService;1"].
      getService(Components.interfaces.koIInfoService);
var gRadioGroup = null;
var paramBlock = null;

//---- interface routines for XUL
function licenseCheckOnOpen()
{
    //dump("gInfoSvc.licenseStatus: "+gInfoSvc.licenseStatus+"\n");
    //dump("gInfoSvc.feature: "+gInfoSvc.feature+"\n");
    //dump("gInfoSvc.featureName: "+gInfoSvc.featureName+"\n");
    if (window.arguments) {
        if (window.arguments[0] instanceof Components.interfaces.nsIDialogParamBlock) {
            paramBlock = window.arguments[0].QueryInterface(Components.interfaces.nsIDialogParamBlock);
            paramBlock.SetInt(0, Components.interfaces.koILicenseCallback.LICCB_ABORT);
        }
    }
    
    if (paramBlock && paramBlock.GetString(1) == "new-trial") {
        // first time run, ask if the user wants to install a trial license
        document.getElementById('new-trial').removeAttribute('collapsed');
        gRadioGroup = document.getElementById('new-trial-radio');
        gRadioGroup.selectedIndex = 0;
        return true;
    }
    
    log.warn("Status: " + gInfoSvc.licenseStatus + ", reason: '" + gInfoSvc.licenseInfo + "'");
    switch (gInfoSvc.licenseStatus) {
    case Components.interfaces.koILicenseInfo.LIC_PERPETUAL:
        ko.dialogs.internalError("Licensing Error", "The licensing system showed this dialog but we have a perpetual license.");
        return false;
        break;
    case Components.interfaces.koILicenseInfo.LIC_TRIAL:
        ko.dialogs.internalError("Licensing Error", "The licensing system showed this dialog but we are in a trial period.");
        return false;
        break;
    case Components.interfaces.koILicenseInfo.LIC_EXPIRED:
        document.getElementById('expired-trial').removeAttribute('collapsed');
        gRadioGroup = document.getElementById('expired-trial-radio');
        gRadioGroup.selectedIndex = 0;
        break;
    case Components.interfaces.koILicenseInfo.LIC_NOFILE:
    case Components.interfaces.koILicenseInfo.LIC_NOTCOVERED:
    case Components.interfaces.koILicenseInfo.LIC_NOFEATURE:
        document.getElementById('invalid-license').removeAttribute('collapsed');
        gRadioGroup = document.getElementById('invalid-license-radio');
        gRadioGroup.selectedIndex = 0;
        break;
    case Components.interfaces.koILicenseInfo.LIC_ENDOFBETA:
        document.getElementById('expired-beta').removeAttribute('collapsed');
        gRadioGroup = document.getElementById('expired-beta-radio');
        gRadioGroup.selectedIndex = 0;
        break;
    default:
        ko.dialogs.internalError("Licensing Error", "The licensing system is providing an unsupported license status ["+gInfoSvc.licenseStatus+"].");
        return false;
    }
    
    return true;
}

function licenseCheckOnClose() {
    // Handle the user's choice.
    switch(gRadioGroup.value) {
    case "install-trial":
        paramBlock.SetInt(0, Components.interfaces.koILicenseCallback.LICCB_CONTINUE);
        break;
    case "retry-license":
        paramBlock.SetInt(0, Components.interfaces.koILicenseCallback.LICCB_RETRY);
        break;
    case "options":
        ko.browse.openUrlInDefaultBrowser("http://komodoide.com/pricing/");
        break;
    case "updates":
        ko.browse.openUrlInDefaultBrowser("http://komodoide.com/download/");
        break;
    case "purchase":
    case "upgrade":
        ko.browse.openUrlInDefaultBrowser("https://store.activestate.com/komodo-ide");
        break;
    case "account":
        ko.browse.openUrlInDefaultBrowser("http://account.activestate.com/");
        break;
    default:
        ko.dialogs.internalError("Licensing Error", "unexpected invalid license choice: '"+gRadioGroup.value+"'\n");
    }
}

function OnLoad()
{
    try {
        var i;
        var dialog = document.getElementById("dialog-invalidlicense")
        gCancelButton = dialog.getButton("cancel");
        gCancelButton.setAttribute("label", "Close");
        gCancelButton.setAttribute("accesskey", "C");

        if (!licenseCheckOnOpen()) {
            window.close();
            return;
        }

        window.sizeToContent();
        // Cannot use dialog.moveToAlertPosition() because that requires
        // a loaded opener window, which this dialog typically does not have.
        dialog.centerWindowOnScreen();
    } catch(ex) {
        log.error(ex, "Error loading invalid license dialog.");
        ko.dialogs.internalError("Licensing Error", ex);
    }
    window.getAttention();
}


function Accept()
{
    try {
        licenseCheckOnClose();
    } catch(ex) {
        log.error(ex);
        ko.dialogs.internalError("Licensing Error", ex);
    }
    return true;
}

function Cancel()
{
    return true;
}

